---
apiVersion: apps/v1
kind: StatefulSet
metadata:
  name: prometheus
spec:
  serviceName: prometheus
  replicas: 1
  selector:
    matchLabels:
      app: prometheus
  template:
    metadata:
      labels:
        app: prometheus
    spec:
      serviceAccount: prometheus
      terminationGracePeriodSeconds: 10
      initContainers:
      - image: busybox
        name: mount-permissions-fix
        command: ["sh", "-c", "chmod 777 /prometheus"]
        volumeMounts:
        - name: data
          mountPath: /prometheus
      containers:
        - name: prometheus-k8s
          image: prom/prometheus:v2.19.2
          env:
            - name: RABBITMQ_USE_LONGNAME
              value: "true"
          ports:
            - containerPort: 9090
              protocol: TCP
          imagePullPolicy: Always
          volumeMounts:
            - name: config-volume
              mountPath: /etc/prometheus
            - name: data
              mountPath: /prometheus
      volumes:
        - name: config-volume
          configMap:
            name: prometheus-configmap
            items:
              - key: prometheus.yaml
                path: prometheus.yaml
      affinity:
        podAntiAffinity:
          preferredDuringSchedulingIgnoredDuringExecution:
            - weight: 100
              podAffinityTerm:
                labelSelector:
                  matchExpressions:
                    - key: app
                      operator: In
                      values:
                        - prometheus
                topologyKey: kubernetes.io/hostname
  volumeClaimTemplates:
    - metadata:
        name: data
      spec:
        accessModes: ["ReadWriteOnce"]
        resources:
          requests:
            storage: 5Gi
        storageClassName: csi-ceph-hdd-ms1
